## org.apache.aries.subsystem.core.internal
Class BasicSubsystem

    java.lang.Object
      org.apache.aries.subsystem.core.internal.BasicSubsystem

All Implemented Interfaces:
  org.apache.aries.subsystem.AriesSubsystem, org.osgi.resource.Resource, org.osgi.service.subsystem.Subsystem

    public class BasicSubsystem

extends Object
implements org.osgi.resource.Resource, org.apache.aries.subsystem.AriesSubsystem

Nested Class Summary

Nested classes/interfaces inherited from interface org.osgi.service.subsystem.Subsystem
`org.osgi.service.subsystem.Subsystem.State`

Field Summary
`static String` `ROOT_LOCATION`
`static String` `ROOT_SYMBOLIC_NAME`
`static org.osgi.framework.Version` `ROOT_VERSION`

Constructor Summary
`BasicSubsystem(File file)`
`BasicSubsystem(org.apache.aries.util.filesystem.IDirectory directory)`
`BasicSubsystem(SubsystemResource resource)`

Method Summary
`void` `addRequirements(Collection<org.osgi.resource.Requirement> requirements)`
`boolean` `equals(Object o)`
`org.osgi.framework.BundleContext` `getBundleContext()`
`List<org.osgi.resource.Capability>` `getCapabilities(String namespace)`
`Collection<org.osgi.service.subsystem.Subsystem>` `getChildren()`
`Collection<org.osgi.resource.Resource>` `getConstituents()`
`String` `getLocation()`
`Collection<org.osgi.service.subsystem.Subsystem>` `getParents()`
`List<org.osgi.resource.Requirement>` `getRequirements(String namespace)`
`org.osgi.service.subsystem.Subsystem.State` `getState()`
`Map<String,String>` `getSubsystemHeaders(Locale locale)`
`long` `getSubsystemId()`
`String` `getSymbolicName()`
`String` `getType()`
`org.osgi.framework.Version` `getVersion()`
`int` `hashCode()`
`org.apache.aries.subsystem.AriesSubsystem` `install(String location)`
`org.apache.aries.subsystem.AriesSubsystem` `install(String location, org.apache.aries.util.filesystem.IDirectory content)`
`org.apache.aries.subsystem.AriesSubsystem` `install(String location, InputStream content)`
`void` `start()`
`void` `stop()`
`void` `uninstall()`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ROOT_SYMBOLIC_NAME

    public static final String ROOT_SYMBOLIC_NAME

See Also:
  Constant Field Values

### ROOT_VERSION

    public static final org.osgi.framework.Version ROOT_VERSION

### ROOT_LOCATION

    public static final String ROOT_LOCATION

Constructor Detail

### BasicSubsystem

    public BasicSubsystem(SubsystemResource resource)
                   throws URISyntaxException,
                          IOException,
                          org.osgi.framework.BundleException,
                          org.osgi.framework.InvalidSyntaxException

Throws:
  `URISyntaxException`
  `IOException`
  `org.osgi.framework.BundleException`
  `org.osgi.framework.InvalidSyntaxException`

### BasicSubsystem

    public BasicSubsystem(File file)
                   throws IOException,
                          URISyntaxException,
                          org.osgi.service.resolver.ResolutionException

Throws:
  `IOException`
  `URISyntaxException`
  `org.osgi.service.resolver.ResolutionException`

### BasicSubsystem

    public BasicSubsystem(org.apache.aries.util.filesystem.IDirectory directory)
                   throws IOException,
                          URISyntaxException,
                          org.osgi.service.resolver.ResolutionException

Throws:
  `IOException`
  `URISyntaxException`
  `org.osgi.service.resolver.ResolutionException`

Method Detail

### equals

    public boolean equals(Object o)

  Specified by:
    `equals` in interface `org.osgi.resource.Resource`
  Overrides:
    `equals` in class `Object`

### getCapabilities

    public List<org.osgi.resource.Capability> getCapabilities(String namespace)

  Specified by:
    `getCapabilities` in interface `org.osgi.resource.Resource`

### getRequirements

    public List<org.osgi.resource.Requirement> getRequirements(String namespace)

  Specified by:
    `getRequirements` in interface `org.osgi.resource.Resource`

### hashCode

    public int hashCode()

  Specified by:
    `hashCode` in interface `org.osgi.resource.Resource`
  Overrides:
    `hashCode` in class `Object`

### getBundleContext

    public org.osgi.framework.BundleContext getBundleContext()

  Specified by:
    `getBundleContext` in interface `org.osgi.service.subsystem.Subsystem`

### getChildren

    public Collection<org.osgi.service.subsystem.Subsystem> getChildren()

  Specified by:
    `getChildren` in interface `org.osgi.service.subsystem.Subsystem`

### getSubsystemHeaders

    public Map<String,String> getSubsystemHeaders(Locale locale)

  Specified by:
    `getSubsystemHeaders` in interface `org.osgi.service.subsystem.Subsystem`

### getLocation

    public String getLocation()

  Specified by:
    `getLocation` in interface `org.osgi.service.subsystem.Subsystem`

### getParents

    public Collection<org.osgi.service.subsystem.Subsystem> getParents()

  Specified by:
    `getParents` in interface `org.osgi.service.subsystem.Subsystem`

### getConstituents

    public Collection<org.osgi.resource.Resource> getConstituents()

  Specified by:
    `getConstituents` in interface `org.osgi.service.subsystem.Subsystem`

### getState

    public org.osgi.service.subsystem.Subsystem.State getState()

  Specified by:
    `getState` in interface `org.osgi.service.subsystem.Subsystem`

### getSubsystemId

    public long getSubsystemId()

  Specified by:
    `getSubsystemId` in interface `org.osgi.service.subsystem.Subsystem`

### getSymbolicName

    public String getSymbolicName()

  Specified by:
    `getSymbolicName` in interface `org.osgi.service.subsystem.Subsystem`

### getType

    public String getType()

  Specified by:
    `getType` in interface `org.osgi.service.subsystem.Subsystem`

### getVersion

    public org.osgi.framework.Version getVersion()

  Specified by:
    `getVersion` in interface `org.osgi.service.subsystem.Subsystem`

### install

    public org.apache.aries.subsystem.AriesSubsystem install(String location)

  Specified by:
    `install` in interface `org.apache.aries.subsystem.AriesSubsystem`
  Specified by:
    `install` in interface `org.osgi.service.subsystem.Subsystem`

### install

    public org.apache.aries.subsystem.AriesSubsystem install(String location,
                                                             InputStream content)

  Specified by:
    `install` in interface `org.apache.aries.subsystem.AriesSubsystem`
  Specified by:
    `install` in interface `org.osgi.service.subsystem.Subsystem`

### start

    public void start()

  Specified by:
    `start` in interface `org.osgi.service.subsystem.Subsystem`

### stop

    public void stop()

  Specified by:
    `stop` in interface `org.osgi.service.subsystem.Subsystem`

### uninstall

    public void uninstall()

  Specified by:
    `uninstall` in interface `org.osgi.service.subsystem.Subsystem`

### addRequirements

    public void addRequirements(Collection<org.osgi.resource.Requirement> requirements)

  Specified by:
    `addRequirements` in interface `org.apache.aries.subsystem.AriesSubsystem`

### install

    public org.apache.aries.subsystem.AriesSubsystem install(String location,
                                                             org.apache.aries.util.filesystem.IDirectory content)

  Specified by:
    `install` in interface `org.apache.aries.subsystem.AriesSubsystem`

Copyright © 2009-2013 The Apache Software Foundation. All Rights Reserved.